/* gpaste-settings.c generated by valac 0.14.0, the Vala compiler
 * generated from gpaste-settings.vala, do not modify */

/*
 *      This file is part of GPaste.
 *
 *      Copyright 2011 Marc-Antoine Perennou <Marc-Antoine@Perennou.com>
 *
 *      GPaste is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      GPaste is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with GPaste.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <config.h>
#include <stdio.h>


#define GPASTE_SETTINGS_TYPE_WINDOW (gpaste_settings_window_get_type ())
#define GPASTE_SETTINGS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_SETTINGS_TYPE_WINDOW, GPasteSettingsWindow))
#define GPASTE_SETTINGS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_SETTINGS_TYPE_WINDOW, GPasteSettingsWindowClass))
#define GPASTE_SETTINGS_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_SETTINGS_TYPE_WINDOW))
#define GPASTE_SETTINGS_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_SETTINGS_TYPE_WINDOW))
#define GPASTE_SETTINGS_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_SETTINGS_TYPE_WINDOW, GPasteSettingsWindowClass))

typedef struct _GPasteSettingsWindow GPasteSettingsWindow;
typedef struct _GPasteSettingsWindowClass GPasteSettingsWindowClass;
typedef struct _GPasteSettingsWindowPrivate GPasteSettingsWindowPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GPASTE_SETTINGS_TYPE_MAIN (gpaste_settings_main_get_type ())
#define GPASTE_SETTINGS_MAIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_SETTINGS_TYPE_MAIN, GPasteSettingsMain))
#define GPASTE_SETTINGS_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_SETTINGS_TYPE_MAIN, GPasteSettingsMainClass))
#define GPASTE_SETTINGS_IS_MAIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_SETTINGS_TYPE_MAIN))
#define GPASTE_SETTINGS_IS_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_SETTINGS_TYPE_MAIN))
#define GPASTE_SETTINGS_MAIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_SETTINGS_TYPE_MAIN, GPasteSettingsMainClass))

typedef struct _GPasteSettingsMain GPasteSettingsMain;
typedef struct _GPasteSettingsMainClass GPasteSettingsMainClass;
typedef struct _Block1Data Block1Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _GPasteSettingsMainPrivate GPasteSettingsMainPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _GPasteSettingsWindow {
	GtkWindow parent_instance;
	GPasteSettingsWindowPrivate * priv;
};

struct _GPasteSettingsWindowClass {
	GtkWindowClass parent_class;
};

struct _GPasteSettingsWindowPrivate {
	GtkCheckButton* primary_to_history_button;
	GtkCheckButton* synchronize_clipboards_button;
	GtkCheckButton* track_changes_button;
	GtkCheckButton* save_history_button;
	GtkSpinButton* max_history_size_button;
	GtkSpinButton* element_size_button;
	GtkEntry* keyboard_shortcut_entry;
};

struct _Block1Data {
	int _ref_count_;
	GPasteSettingsWindow * self;
	GPasteSettingsMain* app;
};

struct _GPasteSettingsMain {
	GtkApplication parent_instance;
	GPasteSettingsMainPrivate * priv;
};

struct _GPasteSettingsMainClass {
	GtkApplicationClass parent_class;
};

struct _GPasteSettingsMainPrivate {
	GSettings* settings;
	GPasteSettingsWindow* window;
};


static gpointer gpaste_settings_window_parent_class = NULL;
static gpointer gpaste_settings_main_parent_class = NULL;

GType gpaste_settings_window_get_type (void) G_GNUC_CONST;
#define GPASTE_SETTINGS_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPASTE_SETTINGS_TYPE_WINDOW, GPasteSettingsWindowPrivate))
enum  {
	GPASTE_SETTINGS_WINDOW_DUMMY_PROPERTY,
	GPASTE_SETTINGS_WINDOW_PRIMARY_TO_HISTORY,
	GPASTE_SETTINGS_WINDOW_SYNCHRONIZE_CLIPBOARDS,
	GPASTE_SETTINGS_WINDOW_TRACK_CHANGES,
	GPASTE_SETTINGS_WINDOW_SAVE_HISTORY,
	GPASTE_SETTINGS_WINDOW_MAX_HISTORY_SIZE,
	GPASTE_SETTINGS_WINDOW_ELEMENT_SIZE,
	GPASTE_SETTINGS_WINDOW_KEYBOARD_SHORTCUT
};
GPasteSettingsWindow* gpaste_settings_window_new (GtkApplication* app);
GPasteSettingsWindow* gpaste_settings_window_construct (GType object_type, GtkApplication* app);
static void gpaste_settings_window_fill (GPasteSettingsWindow* self);
GType gpaste_settings_main_get_type (void) G_GNUC_CONST;
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (Block1Data* _data1_);
gboolean gpaste_settings_main_get_primary_to_history (GPasteSettingsMain* self);
void gpaste_settings_window_set_primary_to_history (GPasteSettingsWindow* self, gboolean value);
static void __lambda1_ (Block1Data* _data1_);
gboolean gpaste_settings_window_get_primary_to_history (GPasteSettingsWindow* self);
void gpaste_settings_main_set_primary_to_history (GPasteSettingsMain* self, gboolean value);
static void ___lambda1__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean gpaste_settings_main_get_synchronize_clipboards (GPasteSettingsMain* self);
void gpaste_settings_window_set_synchronize_clipboards (GPasteSettingsWindow* self, gboolean value);
static void __lambda2_ (Block1Data* _data1_);
gboolean gpaste_settings_window_get_synchronize_clipboards (GPasteSettingsWindow* self);
void gpaste_settings_main_set_synchronize_clipboards (GPasteSettingsMain* self, gboolean value);
static void ___lambda2__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean gpaste_settings_main_get_track_changes (GPasteSettingsMain* self);
void gpaste_settings_window_set_track_changes (GPasteSettingsWindow* self, gboolean value);
static void __lambda3_ (Block1Data* _data1_);
gboolean gpaste_settings_window_get_track_changes (GPasteSettingsWindow* self);
void gpaste_settings_main_set_track_changes (GPasteSettingsMain* self, gboolean value);
static void ___lambda3__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean gpaste_settings_main_get_save_history (GPasteSettingsMain* self);
void gpaste_settings_window_set_save_history (GPasteSettingsWindow* self, gboolean value);
static void __lambda4_ (Block1Data* _data1_);
gboolean gpaste_settings_window_get_save_history (GPasteSettingsWindow* self);
void gpaste_settings_main_set_save_history (GPasteSettingsMain* self, gboolean value);
static void ___lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
guint32 gpaste_settings_main_get_max_history_size (GPasteSettingsMain* self);
void gpaste_settings_window_set_max_history_size (GPasteSettingsWindow* self, guint32 value);
static void __lambda5_ (Block1Data* _data1_);
guint32 gpaste_settings_window_get_max_history_size (GPasteSettingsWindow* self);
void gpaste_settings_main_set_max_history_size (GPasteSettingsMain* self, guint32 value);
static void ___lambda5__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
guint32 gpaste_settings_main_get_element_size (GPasteSettingsMain* self);
void gpaste_settings_window_set_element_size (GPasteSettingsWindow* self, guint32 value);
static void __lambda6_ (Block1Data* _data1_);
guint32 gpaste_settings_window_get_element_size (GPasteSettingsWindow* self);
void gpaste_settings_main_set_element_size (GPasteSettingsMain* self, guint32 value);
static void ___lambda6__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
gchar* gpaste_settings_main_get_keyboard_shortcut (GPasteSettingsMain* self);
void gpaste_settings_window_set_keyboard_shortcut (GPasteSettingsWindow* self, const gchar* value);
static void __lambda7_ (Block1Data* _data1_);
const gchar* gpaste_settings_window_get_keyboard_shortcut (GPasteSettingsWindow* self);
void gpaste_settings_main_set_keyboard_shortcut (GPasteSettingsMain* self, const gchar* value);
static void ___lambda7__gtk_editable_changed (GtkEditable* _sender, gpointer self);
static void gpaste_settings_window_finalize (GObject* obj);
static void _vala_gpaste_settings_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gpaste_settings_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define GPASTE_SETTINGS_MAIN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPASTE_SETTINGS_TYPE_MAIN, GPasteSettingsMainPrivate))
enum  {
	GPASTE_SETTINGS_MAIN_DUMMY_PROPERTY,
	GPASTE_SETTINGS_MAIN_MAX_HISTORY_SIZE,
	GPASTE_SETTINGS_MAIN_ELEMENT_SIZE,
	GPASTE_SETTINGS_MAIN_PRIMARY_TO_HISTORY,
	GPASTE_SETTINGS_MAIN_SYNCHRONIZE_CLIPBOARDS,
	GPASTE_SETTINGS_MAIN_TRACK_CHANGES,
	GPASTE_SETTINGS_MAIN_SAVE_HISTORY,
	GPASTE_SETTINGS_MAIN_KEYBOARD_SHORTCUT
};
GPasteSettingsMain* gpaste_settings_main_new (void);
GPasteSettingsMain* gpaste_settings_main_construct (GType object_type);
static void gpaste_settings_main_init (GPasteSettingsMain* self);
static void _gpaste_settings_main_init_g_application_activate (GApplication* _sender, gpointer self);
static void __lambda0_ (GPasteSettingsMain* self, const gchar* key);
static void ___lambda0__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self);
gint gpaste_settings_main_main (gchar** args, int args_length1);
static GVariant* _variant_new1 (guint32 value);
static GVariant* _variant_new2 (guint32 value);
static void gpaste_settings_main_finalize (GObject* obj);
static void _vala_gpaste_settings_main_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gpaste_settings_main_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GPasteSettingsWindow* gpaste_settings_window_construct (GType object_type, GtkApplication* app) {
	GPasteSettingsWindow * self = NULL;
	const gchar* _tmp0_ = NULL;
	GtkApplication* _tmp1_;
	g_return_val_if_fail (app != NULL, NULL);
	self = (GPasteSettingsWindow*) g_object_new (object_type, "type", GTK_WINDOW_TOPLEVEL, NULL);
	_tmp0_ = _ ("GPaste Settings");
	gtk_window_set_title ((GtkWindow*) self, _tmp0_);
	_tmp1_ = app;
	gtk_window_set_application ((GtkWindow*) self, _tmp1_);
	gtk_window_set_position ((GtkWindow*) self, GTK_WIN_POS_CENTER);
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
	gpaste_settings_window_fill (self);
	return self;
}


GPasteSettingsWindow* gpaste_settings_window_new (GtkApplication* app) {
	return gpaste_settings_window_construct (GPASTE_SETTINGS_TYPE_WINDOW, app);
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (Block1Data* _data1_) {
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		_g_object_unref0 (_data1_->self);
		_g_object_unref0 (_data1_->app);
		g_slice_free (Block1Data, _data1_);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void __lambda1_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_primary_to_history (self);
	_tmp1_ = _tmp0_;
	gpaste_settings_main_set_primary_to_history (_data1_->app, _tmp1_);
}


static void ___lambda1__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda1_ (self);
}


static void __lambda2_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_synchronize_clipboards (self);
	_tmp1_ = _tmp0_;
	gpaste_settings_main_set_synchronize_clipboards (_data1_->app, _tmp1_);
}


static void ___lambda2__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda2_ (self);
}


static void __lambda3_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_track_changes (self);
	_tmp1_ = _tmp0_;
	gpaste_settings_main_set_track_changes (_data1_->app, _tmp1_);
}


static void ___lambda3__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda3_ (self);
}


static void __lambda4_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_save_history (self);
	_tmp1_ = _tmp0_;
	gpaste_settings_main_set_save_history (_data1_->app, _tmp1_);
}


static void ___lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda4_ (self);
}


static void __lambda5_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	guint32 _tmp0_;
	guint32 _tmp1_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_max_history_size (self);
	_tmp1_ = _tmp0_;
	gpaste_settings_main_set_max_history_size (_data1_->app, _tmp1_);
}


static void ___lambda5__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	__lambda5_ (self);
}


static void __lambda6_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	guint32 _tmp0_;
	guint32 _tmp1_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_element_size (self);
	_tmp1_ = _tmp0_;
	gpaste_settings_main_set_element_size (_data1_->app, _tmp1_);
}


static void ___lambda6__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	__lambda6_ (self);
}


static void __lambda7_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_keyboard_shortcut (self);
	_tmp1_ = _tmp0_;
	gpaste_settings_main_set_keyboard_shortcut (_data1_->app, _tmp1_);
}


static void ___lambda7__gtk_editable_changed (GtkEditable* _sender, gpointer self) {
	__lambda7_ (self);
}


static void gpaste_settings_window_fill (GPasteSettingsWindow* self) {
	Block1Data* _data1_;
	GtkVBox* _tmp0_;
	GtkVBox* _tmp1_;
	GtkVBox* labels_vbox;
	const gchar* _tmp2_ = NULL;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* history_size_label;
	const gchar* _tmp5_ = NULL;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* element_size_label;
	const gchar* _tmp8_ = NULL;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* keyboard_shortcut_label;
	GtkApplication* _tmp11_;
	GtkApplication* _tmp12_;
	GPasteSettingsMain* _tmp13_;
	const gchar* _tmp14_ = NULL;
	GtkCheckButton* _tmp15_;
	GtkCheckButton* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	GtkCheckButton* _tmp19_;
	const gchar* _tmp20_ = NULL;
	GtkCheckButton* _tmp21_;
	GtkCheckButton* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	GtkCheckButton* _tmp25_;
	const gchar* _tmp26_ = NULL;
	GtkCheckButton* _tmp27_;
	GtkCheckButton* _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
	GtkCheckButton* _tmp31_;
	const gchar* _tmp32_ = NULL;
	GtkCheckButton* _tmp33_;
	GtkCheckButton* _tmp34_;
	gboolean _tmp35_;
	gboolean _tmp36_;
	GtkCheckButton* _tmp37_;
	GtkSpinButton* _tmp38_;
	GtkSpinButton* _tmp39_;
	guint32 _tmp40_;
	guint32 _tmp41_;
	GtkSpinButton* _tmp42_;
	GtkAdjustment* _tmp43_ = NULL;
	GtkSpinButton* _tmp44_;
	GtkSpinButton* _tmp45_;
	guint32 _tmp46_;
	guint32 _tmp47_;
	GtkSpinButton* _tmp48_;
	GtkAdjustment* _tmp49_ = NULL;
	GtkEntry* _tmp50_;
	GtkEntry* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	GtkEntry* _tmp55_;
	GtkVBox* _tmp56_;
	GtkVBox* _tmp57_;
	GtkVBox* values_vbox;
	GtkSpinButton* _tmp58_;
	GtkSpinButton* _tmp59_;
	GtkEntry* _tmp60_;
	GtkHBox* _tmp61_;
	GtkHBox* _tmp62_;
	GtkHBox* values_hbox;
	GtkVBox* _tmp63_;
	GtkVBox* _tmp64_;
	GtkVBox* vbox;
	GtkCheckButton* _tmp65_;
	GtkCheckButton* _tmp66_;
	GtkCheckButton* _tmp67_;
	GtkCheckButton* _tmp68_;
	g_return_if_fail (self != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = (GtkVBox*) gtk_vbox_new (FALSE, 10);
	_tmp1_ = g_object_ref_sink (_tmp0_);
	labels_vbox = _tmp1_;
	_tmp2_ = _ ("Max history size: ");
	_tmp3_ = (GtkLabel*) gtk_label_new (_tmp2_);
	_tmp4_ = g_object_ref_sink (_tmp3_);
	history_size_label = _tmp4_;
	_tmp5_ = _ ("Max element size when displaying: ");
	_tmp6_ = (GtkLabel*) gtk_label_new (_tmp5_);
	_tmp7_ = g_object_ref_sink (_tmp6_);
	element_size_label = _tmp7_;
	_tmp8_ = _ ("Keyboard shortcut to display the history: ");
	_tmp9_ = (GtkLabel*) gtk_label_new (_tmp8_);
	_tmp10_ = g_object_ref_sink (_tmp9_);
	keyboard_shortcut_label = _tmp10_;
	g_object_set ((GtkMisc*) history_size_label, "xalign", (gfloat) 0, NULL);
	g_object_set ((GtkMisc*) element_size_label, "xalign", (gfloat) 0, NULL);
	g_object_set ((GtkMisc*) keyboard_shortcut_label, "xalign", (gfloat) 0, NULL);
	gtk_container_add ((GtkContainer*) labels_vbox, (GtkWidget*) history_size_label);
	gtk_container_add ((GtkContainer*) labels_vbox, (GtkWidget*) element_size_label);
	gtk_container_add ((GtkContainer*) labels_vbox, (GtkWidget*) keyboard_shortcut_label);
	_tmp11_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp12_ = _tmp11_;
	_tmp13_ = _g_object_ref0 (GPASTE_SETTINGS_IS_MAIN (_tmp12_) ? ((GPasteSettingsMain*) _tmp12_) : NULL);
	_data1_->app = _tmp13_;
	_tmp14_ = _ ("_Primary selection affects history");
	_tmp15_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_tmp14_);
	_tmp16_ = g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->primary_to_history_button);
	self->priv->primary_to_history_button = _tmp16_;
	_tmp17_ = gpaste_settings_main_get_primary_to_history (_data1_->app);
	_tmp18_ = _tmp17_;
	gpaste_settings_window_set_primary_to_history (self, _tmp18_);
	_tmp19_ = self->priv->primary_to_history_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp19_, "toggled", (GCallback) ___lambda1__gtk_toggle_button_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp20_ = _ ("_Synchronize clipboard with primary selection");
	_tmp21_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_tmp20_);
	_tmp22_ = g_object_ref_sink (_tmp21_);
	_g_object_unref0 (self->priv->synchronize_clipboards_button);
	self->priv->synchronize_clipboards_button = _tmp22_;
	_tmp23_ = gpaste_settings_main_get_synchronize_clipboards (_data1_->app);
	_tmp24_ = _tmp23_;
	gpaste_settings_window_set_synchronize_clipboards (self, _tmp24_);
	_tmp25_ = self->priv->synchronize_clipboards_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp25_, "toggled", (GCallback) ___lambda2__gtk_toggle_button_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp26_ = _ ("_Track clipboard changes");
	_tmp27_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_tmp26_);
	_tmp28_ = g_object_ref_sink (_tmp27_);
	_g_object_unref0 (self->priv->track_changes_button);
	self->priv->track_changes_button = _tmp28_;
	_tmp29_ = gpaste_settings_main_get_track_changes (_data1_->app);
	_tmp30_ = _tmp29_;
	gpaste_settings_window_set_track_changes (self, _tmp30_);
	_tmp31_ = self->priv->track_changes_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp31_, "toggled", (GCallback) ___lambda3__gtk_toggle_button_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp32_ = _ ("_Save history");
	_tmp33_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_tmp32_);
	_tmp34_ = g_object_ref_sink (_tmp33_);
	_g_object_unref0 (self->priv->save_history_button);
	self->priv->save_history_button = _tmp34_;
	_tmp35_ = gpaste_settings_main_get_save_history (_data1_->app);
	_tmp36_ = _tmp35_;
	gpaste_settings_window_set_save_history (self, _tmp36_);
	_tmp37_ = self->priv->save_history_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp37_, "toggled", (GCallback) ___lambda4__gtk_toggle_button_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp38_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 5, (gdouble) 255, (gdouble) 5);
	_tmp39_ = g_object_ref_sink (_tmp38_);
	_g_object_unref0 (self->priv->max_history_size_button);
	self->priv->max_history_size_button = _tmp39_;
	_tmp40_ = gpaste_settings_main_get_max_history_size (_data1_->app);
	_tmp41_ = _tmp40_;
	gpaste_settings_window_set_max_history_size (self, _tmp41_);
	_tmp42_ = self->priv->max_history_size_button;
	_tmp43_ = gtk_spin_button_get_adjustment (_tmp42_);
	g_signal_connect_data (_tmp43_, "value-changed", (GCallback) ___lambda5__gtk_adjustment_value_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp44_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 255, (gdouble) 5);
	_tmp45_ = g_object_ref_sink (_tmp44_);
	_g_object_unref0 (self->priv->element_size_button);
	self->priv->element_size_button = _tmp45_;
	_tmp46_ = gpaste_settings_main_get_element_size (_data1_->app);
	_tmp47_ = _tmp46_;
	gpaste_settings_window_set_element_size (self, _tmp47_);
	_tmp48_ = self->priv->element_size_button;
	_tmp49_ = gtk_spin_button_get_adjustment (_tmp48_);
	g_signal_connect_data (_tmp49_, "value-changed", (GCallback) ___lambda6__gtk_adjustment_value_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp50_ = (GtkEntry*) gtk_entry_new ();
	_tmp51_ = g_object_ref_sink (_tmp50_);
	_g_object_unref0 (self->priv->keyboard_shortcut_entry);
	self->priv->keyboard_shortcut_entry = _tmp51_;
	_tmp52_ = gpaste_settings_main_get_keyboard_shortcut (_data1_->app);
	_tmp53_ = _tmp52_;
	_tmp54_ = _tmp53_;
	gpaste_settings_window_set_keyboard_shortcut (self, _tmp54_);
	_g_free0 (_tmp54_);
	_tmp55_ = self->priv->keyboard_shortcut_entry;
	g_signal_connect_data ((GtkEditable*) _tmp55_, "changed", (GCallback) ___lambda7__gtk_editable_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp56_ = (GtkVBox*) gtk_vbox_new (TRUE, 10);
	_tmp57_ = g_object_ref_sink (_tmp56_);
	values_vbox = _tmp57_;
	_tmp58_ = self->priv->max_history_size_button;
	gtk_container_add ((GtkContainer*) values_vbox, (GtkWidget*) _tmp58_);
	_tmp59_ = self->priv->element_size_button;
	gtk_container_add ((GtkContainer*) values_vbox, (GtkWidget*) _tmp59_);
	_tmp60_ = self->priv->keyboard_shortcut_entry;
	gtk_container_add ((GtkContainer*) values_vbox, (GtkWidget*) _tmp60_);
	_tmp61_ = (GtkHBox*) gtk_hbox_new (FALSE, 10);
	_tmp62_ = g_object_ref_sink (_tmp61_);
	values_hbox = _tmp62_;
	gtk_container_add ((GtkContainer*) values_hbox, (GtkWidget*) labels_vbox);
	gtk_container_add ((GtkContainer*) values_hbox, (GtkWidget*) values_vbox);
	_tmp63_ = (GtkVBox*) gtk_vbox_new (FALSE, 10);
	_tmp64_ = g_object_ref_sink (_tmp63_);
	vbox = _tmp64_;
	g_object_set ((GtkWidget*) vbox, "margin", 12, NULL);
	_tmp65_ = self->priv->primary_to_history_button;
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) _tmp65_);
	_tmp66_ = self->priv->synchronize_clipboards_button;
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) _tmp66_);
	_tmp67_ = self->priv->track_changes_button;
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) _tmp67_);
	_tmp68_ = self->priv->save_history_button;
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) _tmp68_);
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) values_hbox);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) vbox);
	_g_object_unref0 (vbox);
	_g_object_unref0 (values_hbox);
	_g_object_unref0 (values_vbox);
	_g_object_unref0 (keyboard_shortcut_label);
	_g_object_unref0 (element_size_label);
	_g_object_unref0 (history_size_label);
	_g_object_unref0 (labels_vbox);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


gboolean gpaste_settings_window_get_primary_to_history (GPasteSettingsWindow* self) {
	gboolean result;
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->primary_to_history_button;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	result = _tmp1_;
	return result;
}


void gpaste_settings_window_set_primary_to_history (GPasteSettingsWindow* self, gboolean value) {
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->primary_to_history_button;
	_tmp1_ = value;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "primary-to-history");
}


gboolean gpaste_settings_window_get_synchronize_clipboards (GPasteSettingsWindow* self) {
	gboolean result;
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->synchronize_clipboards_button;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	result = _tmp1_;
	return result;
}


void gpaste_settings_window_set_synchronize_clipboards (GPasteSettingsWindow* self, gboolean value) {
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->synchronize_clipboards_button;
	_tmp1_ = value;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "synchronize-clipboards");
}


gboolean gpaste_settings_window_get_track_changes (GPasteSettingsWindow* self) {
	gboolean result;
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->track_changes_button;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	result = _tmp1_;
	return result;
}


void gpaste_settings_window_set_track_changes (GPasteSettingsWindow* self, gboolean value) {
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->track_changes_button;
	_tmp1_ = value;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "track-changes");
}


gboolean gpaste_settings_window_get_save_history (GPasteSettingsWindow* self) {
	gboolean result;
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->save_history_button;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	result = _tmp1_;
	return result;
}


void gpaste_settings_window_set_save_history (GPasteSettingsWindow* self, gboolean value) {
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->save_history_button;
	_tmp1_ = value;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "save-history");
}


guint32 gpaste_settings_window_get_max_history_size (GPasteSettingsWindow* self) {
	guint32 result;
	GtkSpinButton* _tmp0_;
	gint _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->max_history_size_button;
	_tmp1_ = gtk_spin_button_get_value_as_int (_tmp0_);
	result = (guint32) _tmp1_;
	return result;
}


void gpaste_settings_window_set_max_history_size (GPasteSettingsWindow* self, guint32 value) {
	GtkSpinButton* _tmp0_;
	GtkAdjustment* _tmp1_ = NULL;
	guint32 _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->max_history_size_button;
	_tmp1_ = gtk_spin_button_get_adjustment (_tmp0_);
	_tmp2_ = value;
	gtk_adjustment_set_value (_tmp1_, (gdouble) _tmp2_);
	g_object_notify ((GObject *) self, "max-history-size");
}


guint32 gpaste_settings_window_get_element_size (GPasteSettingsWindow* self) {
	guint32 result;
	GtkSpinButton* _tmp0_;
	gint _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->element_size_button;
	_tmp1_ = gtk_spin_button_get_value_as_int (_tmp0_);
	result = (guint32) _tmp1_;
	return result;
}


void gpaste_settings_window_set_element_size (GPasteSettingsWindow* self, guint32 value) {
	GtkSpinButton* _tmp0_;
	GtkAdjustment* _tmp1_ = NULL;
	guint32 _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->element_size_button;
	_tmp1_ = gtk_spin_button_get_adjustment (_tmp0_);
	_tmp2_ = value;
	gtk_adjustment_set_value (_tmp1_, (gdouble) _tmp2_);
	g_object_notify ((GObject *) self, "element-size");
}


const gchar* gpaste_settings_window_get_keyboard_shortcut (GPasteSettingsWindow* self) {
	const gchar* result;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->keyboard_shortcut_entry;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	result = _tmp1_;
	return result;
}


void gpaste_settings_window_set_keyboard_shortcut (GPasteSettingsWindow* self, const gchar* value) {
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->keyboard_shortcut_entry;
	_tmp1_ = value;
	gtk_entry_set_text (_tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "keyboard-shortcut");
}


static void gpaste_settings_window_class_init (GPasteSettingsWindowClass * klass) {
	gpaste_settings_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GPasteSettingsWindowPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_gpaste_settings_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gpaste_settings_window_set_property;
	G_OBJECT_CLASS (klass)->finalize = gpaste_settings_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_PRIMARY_TO_HISTORY, g_param_spec_boolean ("primary-to-history", "primary-to-history", "primary-to-history", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_SYNCHRONIZE_CLIPBOARDS, g_param_spec_boolean ("synchronize-clipboards", "synchronize-clipboards", "synchronize-clipboards", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_TRACK_CHANGES, g_param_spec_boolean ("track-changes", "track-changes", "track-changes", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_SAVE_HISTORY, g_param_spec_boolean ("save-history", "save-history", "save-history", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_MAX_HISTORY_SIZE, g_param_spec_uint ("max-history-size", "max-history-size", "max-history-size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_ELEMENT_SIZE, g_param_spec_uint ("element-size", "element-size", "element-size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_KEYBOARD_SHORTCUT, g_param_spec_string ("keyboard-shortcut", "keyboard-shortcut", "keyboard-shortcut", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void gpaste_settings_window_instance_init (GPasteSettingsWindow * self) {
	self->priv = GPASTE_SETTINGS_WINDOW_GET_PRIVATE (self);
}


static void gpaste_settings_window_finalize (GObject* obj) {
	GPasteSettingsWindow * self;
	self = GPASTE_SETTINGS_WINDOW (obj);
	_g_object_unref0 (self->priv->primary_to_history_button);
	_g_object_unref0 (self->priv->synchronize_clipboards_button);
	_g_object_unref0 (self->priv->track_changes_button);
	_g_object_unref0 (self->priv->save_history_button);
	_g_object_unref0 (self->priv->max_history_size_button);
	_g_object_unref0 (self->priv->element_size_button);
	_g_object_unref0 (self->priv->keyboard_shortcut_entry);
	G_OBJECT_CLASS (gpaste_settings_window_parent_class)->finalize (obj);
}


GType gpaste_settings_window_get_type (void) {
	static volatile gsize gpaste_settings_window_type_id__volatile = 0;
	if (g_once_init_enter (&gpaste_settings_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPasteSettingsWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpaste_settings_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GPasteSettingsWindow), 0, (GInstanceInitFunc) gpaste_settings_window_instance_init, NULL };
		GType gpaste_settings_window_type_id;
		gpaste_settings_window_type_id = g_type_register_static (GTK_TYPE_WINDOW, "GPasteSettingsWindow", &g_define_type_info, 0);
		g_once_init_leave (&gpaste_settings_window_type_id__volatile, gpaste_settings_window_type_id);
	}
	return gpaste_settings_window_type_id__volatile;
}


static void _vala_gpaste_settings_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GPasteSettingsWindow * self;
	self = GPASTE_SETTINGS_WINDOW (object);
	switch (property_id) {
		case GPASTE_SETTINGS_WINDOW_PRIMARY_TO_HISTORY:
		g_value_set_boolean (value, gpaste_settings_window_get_primary_to_history (self));
		break;
		case GPASTE_SETTINGS_WINDOW_SYNCHRONIZE_CLIPBOARDS:
		g_value_set_boolean (value, gpaste_settings_window_get_synchronize_clipboards (self));
		break;
		case GPASTE_SETTINGS_WINDOW_TRACK_CHANGES:
		g_value_set_boolean (value, gpaste_settings_window_get_track_changes (self));
		break;
		case GPASTE_SETTINGS_WINDOW_SAVE_HISTORY:
		g_value_set_boolean (value, gpaste_settings_window_get_save_history (self));
		break;
		case GPASTE_SETTINGS_WINDOW_MAX_HISTORY_SIZE:
		g_value_set_uint (value, gpaste_settings_window_get_max_history_size (self));
		break;
		case GPASTE_SETTINGS_WINDOW_ELEMENT_SIZE:
		g_value_set_uint (value, gpaste_settings_window_get_element_size (self));
		break;
		case GPASTE_SETTINGS_WINDOW_KEYBOARD_SHORTCUT:
		g_value_set_string (value, gpaste_settings_window_get_keyboard_shortcut (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gpaste_settings_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GPasteSettingsWindow * self;
	self = GPASTE_SETTINGS_WINDOW (object);
	switch (property_id) {
		case GPASTE_SETTINGS_WINDOW_PRIMARY_TO_HISTORY:
		gpaste_settings_window_set_primary_to_history (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_WINDOW_SYNCHRONIZE_CLIPBOARDS:
		gpaste_settings_window_set_synchronize_clipboards (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_WINDOW_TRACK_CHANGES:
		gpaste_settings_window_set_track_changes (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_WINDOW_SAVE_HISTORY:
		gpaste_settings_window_set_save_history (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_WINDOW_MAX_HISTORY_SIZE:
		gpaste_settings_window_set_max_history_size (self, g_value_get_uint (value));
		break;
		case GPASTE_SETTINGS_WINDOW_ELEMENT_SIZE:
		gpaste_settings_window_set_element_size (self, g_value_get_uint (value));
		break;
		case GPASTE_SETTINGS_WINDOW_KEYBOARD_SHORTCUT:
		gpaste_settings_window_set_keyboard_shortcut (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _gpaste_settings_main_init_g_application_activate (GApplication* _sender, gpointer self) {
	gpaste_settings_main_init (self);
}


static void __lambda0_ (GPasteSettingsMain* self, const gchar* key) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	static GQuark _tmp2_label2 = 0;
	static GQuark _tmp2_label3 = 0;
	static GQuark _tmp2_label4 = 0;
	static GQuark _tmp2_label5 = 0;
	static GQuark _tmp2_label6 = 0;
	g_return_if_fail (key != NULL);
	_tmp0_ = key;
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("max-history-size")))) {
		switch (0) {
			default:
			{
				GPasteSettingsWindow* _tmp4_;
				guint32 _tmp5_;
				guint32 _tmp6_;
				_tmp4_ = self->priv->window;
				_tmp5_ = gpaste_settings_main_get_max_history_size (self);
				_tmp6_ = _tmp5_;
				gpaste_settings_window_set_max_history_size (_tmp4_, _tmp6_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("element-size")))) {
		switch (0) {
			default:
			{
				GPasteSettingsWindow* _tmp7_;
				guint32 _tmp8_;
				guint32 _tmp9_;
				_tmp7_ = self->priv->window;
				_tmp8_ = gpaste_settings_main_get_element_size (self);
				_tmp9_ = _tmp8_;
				gpaste_settings_window_set_element_size (_tmp7_, _tmp9_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("primary-to-history")))) {
		switch (0) {
			default:
			{
				GPasteSettingsWindow* _tmp10_;
				gboolean _tmp11_;
				gboolean _tmp12_;
				_tmp10_ = self->priv->window;
				_tmp11_ = gpaste_settings_main_get_primary_to_history (self);
				_tmp12_ = _tmp11_;
				gpaste_settings_window_set_primary_to_history (_tmp10_, _tmp12_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("synchronize_clipboards")))) {
		switch (0) {
			default:
			{
				GPasteSettingsWindow* _tmp13_;
				gboolean _tmp14_;
				gboolean _tmp15_;
				_tmp13_ = self->priv->window;
				_tmp14_ = gpaste_settings_main_get_synchronize_clipboards (self);
				_tmp15_ = _tmp14_;
				gpaste_settings_window_set_synchronize_clipboards (_tmp13_, _tmp15_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("track-changes")))) {
		switch (0) {
			default:
			{
				GPasteSettingsWindow* _tmp16_;
				gboolean _tmp17_;
				gboolean _tmp18_;
				_tmp16_ = self->priv->window;
				_tmp17_ = gpaste_settings_main_get_track_changes (self);
				_tmp18_ = _tmp17_;
				gpaste_settings_window_set_track_changes (_tmp16_, _tmp18_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("save-history")))) {
		switch (0) {
			default:
			{
				GPasteSettingsWindow* _tmp19_;
				gboolean _tmp20_;
				gboolean _tmp21_;
				_tmp19_ = self->priv->window;
				_tmp20_ = gpaste_settings_main_get_save_history (self);
				_tmp21_ = _tmp20_;
				gpaste_settings_window_set_save_history (_tmp19_, _tmp21_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("keyboard-shortcut")))) {
		switch (0) {
			default:
			{
				GPasteSettingsWindow* _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				_tmp22_ = self->priv->window;
				_tmp23_ = gpaste_settings_main_get_keyboard_shortcut (self);
				_tmp24_ = _tmp23_;
				_tmp25_ = _tmp24_;
				gpaste_settings_window_set_keyboard_shortcut (_tmp22_, _tmp25_);
				_g_free0 (_tmp25_);
				break;
			}
		}
	}
}


static void ___lambda0__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self) {
	__lambda0_ (self, key);
}


GPasteSettingsMain* gpaste_settings_main_construct (GType object_type) {
	GPasteSettingsMain * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	self = (GPasteSettingsMain*) g_object_new (object_type, "application-id", "org.gnome.GPaste.Settings", NULL);
	g_signal_connect_object ((GApplication*) self, "activate", (GCallback) _gpaste_settings_main_init_g_application_activate, self, 0);
	_tmp0_ = g_settings_new ("org.gnome.GPaste");
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = self->priv->settings;
	g_signal_connect_object (_tmp1_, "changed", (GCallback) ___lambda0__g_settings_changed, self, 0);
	return self;
}


GPasteSettingsMain* gpaste_settings_main_new (void) {
	return gpaste_settings_main_construct (GPASTE_SETTINGS_TYPE_MAIN);
}


static void gpaste_settings_main_init (GPasteSettingsMain* self) {
	GPasteSettingsWindow* _tmp0_;
	GPasteSettingsWindow* _tmp1_;
	GPasteSettingsWindow* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gpaste_settings_window_new ((GtkApplication*) self);
	_tmp1_ = g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->window);
	self->priv->window = _tmp1_;
	_tmp2_ = self->priv->window;
	gtk_widget_show_all ((GtkWidget*) _tmp2_);
}


gint gpaste_settings_main_main (gchar** args, int args_length1) {
	gint result = 0;
	GPasteSettingsMain* _tmp0_;
	GPasteSettingsMain* app;
	GPasteSettingsMain* _tmp4_;
	gint _tmp5_ = 0;
	GError * _inner_error_ = NULL;
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
	gtk_init (&args_length1, &args);
	_tmp0_ = gpaste_settings_main_new ();
	app = _tmp0_;
	{
		GPasteSettingsMain* _tmp1_;
		_tmp1_ = app;
		g_application_register ((GApplication*) _tmp1_, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp2_;
		const gchar* _tmp3_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = stderr;
		_tmp3_ = _ ("Fail to register the gtk application.\n");
		fprintf (_tmp2_, "%s", _tmp3_);
		result = 1;
		_g_error_free0 (e);
		_g_object_unref0 (app);
		return result;
	}
	__finally0:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (app);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
	_tmp4_ = app;
	_tmp5_ = g_application_run ((GApplication*) _tmp4_, 0, NULL);
	result = _tmp5_;
	_g_object_unref0 (app);
	return result;
}


int main (int argc, char ** argv) {
	g_type_init ();
	return gpaste_settings_main_main (argv, argc);
}


guint32 gpaste_settings_main_get_max_history_size (GPasteSettingsMain* self) {
	guint32 result;
	GSettings* _tmp0_;
	GVariant* _tmp1_ = NULL;
	GVariant* _tmp2_;
	guint32 _tmp3_ = 0U;
	guint32 _tmp4_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_value (_tmp0_, "max-history-size");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_variant_get_uint32 (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_variant_unref0 (_tmp2_);
	result = _tmp4_;
	return result;
}


static GVariant* _variant_new1 (guint32 value) {
	return g_variant_ref_sink (g_variant_new_uint32 (value));
}


void gpaste_settings_main_set_max_history_size (GPasteSettingsMain* self, guint32 value) {
	GSettings* _tmp0_;
	guint32 _tmp1_;
	GVariant* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	_tmp2_ = _variant_new1 (_tmp1_);
	g_settings_set_value (_tmp0_, "max-history-size", _tmp2_);
	g_object_notify ((GObject *) self, "max-history-size");
}


guint32 gpaste_settings_main_get_element_size (GPasteSettingsMain* self) {
	guint32 result;
	GSettings* _tmp0_;
	GVariant* _tmp1_ = NULL;
	GVariant* _tmp2_;
	guint32 _tmp3_ = 0U;
	guint32 _tmp4_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_value (_tmp0_, "element-size");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_variant_get_uint32 (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_variant_unref0 (_tmp2_);
	result = _tmp4_;
	return result;
}


static GVariant* _variant_new2 (guint32 value) {
	return g_variant_ref_sink (g_variant_new_uint32 (value));
}


void gpaste_settings_main_set_element_size (GPasteSettingsMain* self, guint32 value) {
	GSettings* _tmp0_;
	guint32 _tmp1_;
	GVariant* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	_tmp2_ = _variant_new2 (_tmp1_);
	g_settings_set_value (_tmp0_, "element-size", _tmp2_);
	g_object_notify ((GObject *) self, "element-size");
}


gboolean gpaste_settings_main_get_primary_to_history (GPasteSettingsMain* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_boolean (_tmp0_, "primary-to-history");
	result = _tmp1_;
	return result;
}


void gpaste_settings_main_set_primary_to_history (GPasteSettingsMain* self, gboolean value) {
	GSettings* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_settings_set_boolean (_tmp0_, "primary-to-history", _tmp1_);
	g_object_notify ((GObject *) self, "primary-to-history");
}


gboolean gpaste_settings_main_get_synchronize_clipboards (GPasteSettingsMain* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_boolean (_tmp0_, "synchronize-clipboards");
	result = _tmp1_;
	return result;
}


void gpaste_settings_main_set_synchronize_clipboards (GPasteSettingsMain* self, gboolean value) {
	GSettings* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_settings_set_boolean (_tmp0_, "synchronize-clipboards", _tmp1_);
	g_object_notify ((GObject *) self, "synchronize-clipboards");
}


gboolean gpaste_settings_main_get_track_changes (GPasteSettingsMain* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_boolean (_tmp0_, "track-changes");
	result = _tmp1_;
	return result;
}


void gpaste_settings_main_set_track_changes (GPasteSettingsMain* self, gboolean value) {
	GSettings* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_settings_set_boolean (_tmp0_, "track-changes", _tmp1_);
	g_object_notify ((GObject *) self, "track-changes");
}


gboolean gpaste_settings_main_get_save_history (GPasteSettingsMain* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_boolean (_tmp0_, "save-history");
	result = _tmp1_;
	return result;
}


void gpaste_settings_main_set_save_history (GPasteSettingsMain* self, gboolean value) {
	GSettings* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_settings_set_boolean (_tmp0_, "save-history", _tmp1_);
	g_object_notify ((GObject *) self, "save-history");
}


gchar* gpaste_settings_main_get_keyboard_shortcut (GPasteSettingsMain* self) {
	gchar* result;
	GSettings* _tmp0_;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_string (_tmp0_, "keyboard-shortcut");
	result = _tmp1_;
	return result;
}


void gpaste_settings_main_set_keyboard_shortcut (GPasteSettingsMain* self, const gchar* value) {
	GSettings* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_settings_set_string (_tmp0_, "keyboard-shortcut", _tmp1_);
	g_object_notify ((GObject *) self, "keyboard-shortcut");
}


static void gpaste_settings_main_class_init (GPasteSettingsMainClass * klass) {
	gpaste_settings_main_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GPasteSettingsMainPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_gpaste_settings_main_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gpaste_settings_main_set_property;
	G_OBJECT_CLASS (klass)->finalize = gpaste_settings_main_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_MAX_HISTORY_SIZE, g_param_spec_uint ("max-history-size", "max-history-size", "max-history-size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_ELEMENT_SIZE, g_param_spec_uint ("element-size", "element-size", "element-size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_PRIMARY_TO_HISTORY, g_param_spec_boolean ("primary-to-history", "primary-to-history", "primary-to-history", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_SYNCHRONIZE_CLIPBOARDS, g_param_spec_boolean ("synchronize-clipboards", "synchronize-clipboards", "synchronize-clipboards", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_TRACK_CHANGES, g_param_spec_boolean ("track-changes", "track-changes", "track-changes", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_SAVE_HISTORY, g_param_spec_boolean ("save-history", "save-history", "save-history", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_KEYBOARD_SHORTCUT, g_param_spec_string ("keyboard-shortcut", "keyboard-shortcut", "keyboard-shortcut", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void gpaste_settings_main_instance_init (GPasteSettingsMain * self) {
	self->priv = GPASTE_SETTINGS_MAIN_GET_PRIVATE (self);
}


static void gpaste_settings_main_finalize (GObject* obj) {
	GPasteSettingsMain * self;
	self = GPASTE_SETTINGS_MAIN (obj);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->window);
	G_OBJECT_CLASS (gpaste_settings_main_parent_class)->finalize (obj);
}


GType gpaste_settings_main_get_type (void) {
	static volatile gsize gpaste_settings_main_type_id__volatile = 0;
	if (g_once_init_enter (&gpaste_settings_main_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPasteSettingsMainClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpaste_settings_main_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GPasteSettingsMain), 0, (GInstanceInitFunc) gpaste_settings_main_instance_init, NULL };
		GType gpaste_settings_main_type_id;
		gpaste_settings_main_type_id = g_type_register_static (GTK_TYPE_APPLICATION, "GPasteSettingsMain", &g_define_type_info, 0);
		g_once_init_leave (&gpaste_settings_main_type_id__volatile, gpaste_settings_main_type_id);
	}
	return gpaste_settings_main_type_id__volatile;
}


static void _vala_gpaste_settings_main_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GPasteSettingsMain * self;
	self = GPASTE_SETTINGS_MAIN (object);
	switch (property_id) {
		case GPASTE_SETTINGS_MAIN_MAX_HISTORY_SIZE:
		g_value_set_uint (value, gpaste_settings_main_get_max_history_size (self));
		break;
		case GPASTE_SETTINGS_MAIN_ELEMENT_SIZE:
		g_value_set_uint (value, gpaste_settings_main_get_element_size (self));
		break;
		case GPASTE_SETTINGS_MAIN_PRIMARY_TO_HISTORY:
		g_value_set_boolean (value, gpaste_settings_main_get_primary_to_history (self));
		break;
		case GPASTE_SETTINGS_MAIN_SYNCHRONIZE_CLIPBOARDS:
		g_value_set_boolean (value, gpaste_settings_main_get_synchronize_clipboards (self));
		break;
		case GPASTE_SETTINGS_MAIN_TRACK_CHANGES:
		g_value_set_boolean (value, gpaste_settings_main_get_track_changes (self));
		break;
		case GPASTE_SETTINGS_MAIN_SAVE_HISTORY:
		g_value_set_boolean (value, gpaste_settings_main_get_save_history (self));
		break;
		case GPASTE_SETTINGS_MAIN_KEYBOARD_SHORTCUT:
		g_value_take_string (value, gpaste_settings_main_get_keyboard_shortcut (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gpaste_settings_main_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GPasteSettingsMain * self;
	self = GPASTE_SETTINGS_MAIN (object);
	switch (property_id) {
		case GPASTE_SETTINGS_MAIN_MAX_HISTORY_SIZE:
		gpaste_settings_main_set_max_history_size (self, g_value_get_uint (value));
		break;
		case GPASTE_SETTINGS_MAIN_ELEMENT_SIZE:
		gpaste_settings_main_set_element_size (self, g_value_get_uint (value));
		break;
		case GPASTE_SETTINGS_MAIN_PRIMARY_TO_HISTORY:
		gpaste_settings_main_set_primary_to_history (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_MAIN_SYNCHRONIZE_CLIPBOARDS:
		gpaste_settings_main_set_synchronize_clipboards (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_MAIN_TRACK_CHANGES:
		gpaste_settings_main_set_track_changes (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_MAIN_SAVE_HISTORY:
		gpaste_settings_main_set_save_history (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_MAIN_KEYBOARD_SHORTCUT:
		gpaste_settings_main_set_keyboard_shortcut (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



