/* item.c generated by valac 0.14.0, the Vala compiler
 * generated from item.vala, do not modify */

/*
 *      This file is part of GPaste.
 *
 *      Copyright 2011 Marc-Antoine Perennou <Marc-Antoine@Perennou.com>
 *
 *      GPaste is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      GPaste is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with GPaste.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define GPASTE_DAEMON_TYPE_ITEM_KIND (gpaste_daemon_item_kind_get_type ())

#define GPASTE_DAEMON_TYPE_ITEM (gpaste_daemon_item_get_type ())
typedef struct _GPasteDaemonItem GPasteDaemonItem;
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	GPASTE_DAEMON_ITEM_KIND_STRING,
	GPASTE_DAEMON_ITEM_KIND_IMAGE
} GPasteDaemonItemKind;

struct _GPasteDaemonItem {
	GPasteDaemonItemKind kind;
	gchar* val;
};



GType gpaste_daemon_item_kind_get_type (void) G_GNUC_CONST;
GType gpaste_daemon_item_get_type (void) G_GNUC_CONST;
GPasteDaemonItem* gpaste_daemon_item_dup (const GPasteDaemonItem* self);
void gpaste_daemon_item_free (GPasteDaemonItem* self);
void gpaste_daemon_item_copy (const GPasteDaemonItem* self, GPasteDaemonItem* dest);
void gpaste_daemon_item_destroy (GPasteDaemonItem* self);
void gpaste_daemon_item_init (GPasteDaemonItem *self, GPasteDaemonItemKind kind, const gchar* val);


GType gpaste_daemon_item_kind_get_type (void) {
	static volatile gsize gpaste_daemon_item_kind_type_id__volatile = 0;
	if (g_once_init_enter (&gpaste_daemon_item_kind_type_id__volatile)) {
		static const GEnumValue values[] = {{GPASTE_DAEMON_ITEM_KIND_STRING, "GPASTE_DAEMON_ITEM_KIND_STRING", "string"}, {GPASTE_DAEMON_ITEM_KIND_IMAGE, "GPASTE_DAEMON_ITEM_KIND_IMAGE", "image"}, {0, NULL, NULL}};
		GType gpaste_daemon_item_kind_type_id;
		gpaste_daemon_item_kind_type_id = g_enum_register_static ("GPasteDaemonItemKind", values);
		g_once_init_leave (&gpaste_daemon_item_kind_type_id__volatile, gpaste_daemon_item_kind_type_id);
	}
	return gpaste_daemon_item_kind_type_id__volatile;
}


void gpaste_daemon_item_init (GPasteDaemonItem *self, GPasteDaemonItemKind kind, const gchar* val) {
	GPasteDaemonItemKind _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (val != NULL);
	memset (self, 0, sizeof (GPasteDaemonItem));
	_tmp0_ = kind;
	(*self).kind = _tmp0_;
	_tmp1_ = val;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 ((*self).val);
	(*self).val = _tmp2_;
}


void gpaste_daemon_item_copy (const GPasteDaemonItem* self, GPasteDaemonItem* dest) {
	GPasteDaemonItemKind _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	_tmp0_ = (*self).kind;
	(*dest).kind = _tmp0_;
	_tmp1_ = (*self).val;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 ((*dest).val);
	(*dest).val = _tmp2_;
}


void gpaste_daemon_item_destroy (GPasteDaemonItem* self) {
	_g_free0 ((*self).val);
}


GPasteDaemonItem* gpaste_daemon_item_dup (const GPasteDaemonItem* self) {
	GPasteDaemonItem* dup;
	dup = g_new0 (GPasteDaemonItem, 1);
	gpaste_daemon_item_copy (self, dup);
	return dup;
}


void gpaste_daemon_item_free (GPasteDaemonItem* self) {
	gpaste_daemon_item_destroy (self);
	g_free (self);
}


GType gpaste_daemon_item_get_type (void) {
	static volatile gsize gpaste_daemon_item_type_id__volatile = 0;
	if (g_once_init_enter (&gpaste_daemon_item_type_id__volatile)) {
		GType gpaste_daemon_item_type_id;
		gpaste_daemon_item_type_id = g_boxed_type_register_static ("GPasteDaemonItem", (GBoxedCopyFunc) gpaste_daemon_item_dup, (GBoxedFreeFunc) gpaste_daemon_item_free);
		g_once_init_leave (&gpaste_daemon_item_type_id__volatile, gpaste_daemon_item_type_id);
	}
	return gpaste_daemon_item_type_id__volatile;
}



