/* keybinder.c generated by valac 0.14.0, the Vala compiler
 * generated from keybinder.vala, do not modify */

/*
 *      This file is part of GPaste.
 *
 *      Copyright 2011 Marc-Antoine Perennou <Marc-Antoine@Perennou.com>
 *
 *      GPaste is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      GPaste is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with GPaste.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <gtk/gtk.h>
#include <gio/gio.h>


#define GPASTE_DAEMON_TYPE_KEYBINDER (gpaste_daemon_keybinder_get_type ())
#define GPASTE_DAEMON_KEYBINDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_DAEMON_TYPE_KEYBINDER, GPasteDaemonKeybinder))
#define GPASTE_DAEMON_KEYBINDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_DAEMON_TYPE_KEYBINDER, GPasteDaemonKeybinderClass))
#define GPASTE_DAEMON_IS_KEYBINDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_DAEMON_TYPE_KEYBINDER))
#define GPASTE_DAEMON_IS_KEYBINDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_DAEMON_TYPE_KEYBINDER))
#define GPASTE_DAEMON_KEYBINDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_DAEMON_TYPE_KEYBINDER, GPasteDaemonKeybinderClass))

typedef struct _GPasteDaemonKeybinder GPasteDaemonKeybinder;
typedef struct _GPasteDaemonKeybinderClass GPasteDaemonKeybinderClass;
typedef struct _GPasteDaemonKeybinderPrivate GPasteDaemonKeybinderPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GPASTE_DAEMON_TYPE_DBUS_SERVER (gpaste_daemon_dbus_server_get_type ())
#define GPASTE_DAEMON_DBUS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_DAEMON_TYPE_DBUS_SERVER, GPasteDaemonDBusServer))
#define GPASTE_DAEMON_DBUS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_DAEMON_TYPE_DBUS_SERVER, GPasteDaemonDBusServerClass))
#define GPASTE_DAEMON_IS_DBUS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_DAEMON_TYPE_DBUS_SERVER))
#define GPASTE_DAEMON_IS_DBUS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_DAEMON_TYPE_DBUS_SERVER))
#define GPASTE_DAEMON_DBUS_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_DAEMON_TYPE_DBUS_SERVER, GPasteDaemonDBusServerClass))

typedef struct _GPasteDaemonDBusServer GPasteDaemonDBusServer;
typedef struct _GPasteDaemonDBusServerClass GPasteDaemonDBusServerClass;

struct _GPasteDaemonKeybinder {
	GObject parent_instance;
	GPasteDaemonKeybinderPrivate * priv;
};

struct _GPasteDaemonKeybinderClass {
	GObjectClass parent_class;
};

struct _GPasteDaemonKeybinderPrivate {
	gint _keycode;
	GdkModifierType _modifiers;
};


static gpointer gpaste_daemon_keybinder_parent_class = NULL;
static GPasteDaemonKeybinder* gpaste_daemon_keybinder__instance;
static GPasteDaemonKeybinder* gpaste_daemon_keybinder__instance = NULL;

GType gpaste_daemon_keybinder_get_type (void) G_GNUC_CONST;
#define GPASTE_DAEMON_KEYBINDER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPASTE_DAEMON_TYPE_KEYBINDER, GPasteDaemonKeybinderPrivate))
enum  {
	GPASTE_DAEMON_KEYBINDER_DUMMY_PROPERTY,
	GPASTE_DAEMON_KEYBINDER_KEYCODE,
	GPASTE_DAEMON_KEYBINDER_MODIFIERS
};
void gpaste_daemon_keybinder_init (const gchar* accelerator);
GPasteDaemonKeybinder* gpaste_daemon_keybinder_get_instance (void);
static GPasteDaemonKeybinder* gpaste_daemon_keybinder_new (const gchar* accelerator);
static GPasteDaemonKeybinder* gpaste_daemon_keybinder_construct (GType object_type, const gchar* accelerator);
static void gpaste_daemon_keybinder_set_instance (GPasteDaemonKeybinder* value);
static GdkFilterReturn gpaste_daemon_keybinder_event_filter (GPasteDaemonKeybinder* self, GdkXEvent* gdk_xevent, GdkEvent* gdk_event);
static GdkFilterReturn _gpaste_daemon_keybinder_event_filter_gdk_filter_func (GdkXEvent* xevent, GdkEvent* event, gpointer self);
static void gpaste_daemon_keybinder_activate (GPasteDaemonKeybinder* self, const gchar* accelerator);
void gpaste_daemon_keybinder_unbind (GPasteDaemonKeybinder* self);
gint gpaste_daemon_keybinder_get_keycode (GPasteDaemonKeybinder* self);
GdkModifierType gpaste_daemon_keybinder_get_modifiers (GPasteDaemonKeybinder* self);
void gpaste_daemon_keybinder_rebind (GPasteDaemonKeybinder* self, const gchar* accelerator);
static void gpaste_daemon_keybinder_set_keycode (GPasteDaemonKeybinder* self, gint value);
static void gpaste_daemon_keybinder_set_modifiers (GPasteDaemonKeybinder* self, GdkModifierType value);
GType gpaste_daemon_dbus_server_get_type (void) G_GNUC_CONST;
guint gpaste_daemon_dbus_server_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GPasteDaemonDBusServer* gpaste_daemon_dbus_server_get_instance (void);
static void gpaste_daemon_keybinder_finalize (GObject* obj);
static void _vala_gpaste_daemon_keybinder_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gpaste_daemon_keybinder_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static GdkFilterReturn _gpaste_daemon_keybinder_event_filter_gdk_filter_func (GdkXEvent* xevent, GdkEvent* event, gpointer self) {
	GdkFilterReturn result;
	result = gpaste_daemon_keybinder_event_filter (self, xevent, event);
	return result;
}


void gpaste_daemon_keybinder_init (const gchar* accelerator) {
	GPasteDaemonKeybinder* _tmp0_;
	GPasteDaemonKeybinder* _tmp1_;
	GPasteDaemonKeybinder* _tmp2_;
	GPasteDaemonKeybinder* _tmp3_;
	const gchar* _tmp4_;
	GPasteDaemonKeybinder* _tmp5_;
	GPasteDaemonKeybinder* _tmp6_;
	GdkWindow* _tmp7_ = NULL;
	GdkWindow* _tmp8_;
	GdkWindow* rootwin;
	GdkWindow* _tmp9_;
	g_return_if_fail (accelerator != NULL);
	_tmp0_ = gpaste_daemon_keybinder_get_instance ();
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		return;
	}
	_tmp2_ = gpaste_daemon_keybinder_get_instance ();
	_tmp3_ = _tmp2_;
	_tmp4_ = accelerator;
	_tmp5_ = gpaste_daemon_keybinder_new (_tmp4_);
	_tmp6_ = _tmp5_;
	gpaste_daemon_keybinder_set_instance (_tmp6_);
	_g_object_unref0 (_tmp6_);
	_tmp7_ = gdk_get_default_root_window ();
	_tmp8_ = _g_object_ref0 (_tmp7_);
	rootwin = _tmp8_;
	_tmp9_ = rootwin;
	if (_tmp9_ != NULL) {
		GdkWindow* _tmp10_;
		GPasteDaemonKeybinder* _tmp11_;
		GPasteDaemonKeybinder* _tmp12_;
		_tmp10_ = rootwin;
		_tmp11_ = gpaste_daemon_keybinder_get_instance ();
		_tmp12_ = _tmp11_;
		gdk_window_add_filter (_tmp10_, _gpaste_daemon_keybinder_event_filter_gdk_filter_func, _tmp12_);
	}
	_g_object_unref0 (rootwin);
}


static GPasteDaemonKeybinder* gpaste_daemon_keybinder_construct (GType object_type, const gchar* accelerator) {
	GPasteDaemonKeybinder * self = NULL;
	const gchar* _tmp0_;
	g_return_val_if_fail (accelerator != NULL, NULL);
	self = (GPasteDaemonKeybinder*) g_object_new (object_type, NULL);
	_tmp0_ = accelerator;
	gpaste_daemon_keybinder_activate (self, _tmp0_);
	return self;
}


static GPasteDaemonKeybinder* gpaste_daemon_keybinder_new (const gchar* accelerator) {
	return gpaste_daemon_keybinder_construct (GPASTE_DAEMON_TYPE_KEYBINDER, accelerator);
}


void gpaste_daemon_keybinder_unbind (GPasteDaemonKeybinder* self) {
	GdkWindow* _tmp0_ = NULL;
	GdkWindow* _tmp1_;
	GdkWindow* rootwin;
	Window _tmp2_ = 0;
	XID xid;
	Display* _tmp3_ = NULL;
	Display* display;
	gint _tmp4_;
	GdkModifierType _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gdk_get_default_root_window ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	rootwin = _tmp1_;
	_tmp2_ = gdk_x11_window_get_xid (rootwin);
	xid = (XID) _tmp2_;
	_tmp3_ = gdk_x11_get_default_xdisplay ();
	display = _tmp3_;
	_tmp4_ = self->priv->_keycode;
	_tmp5_ = self->priv->_modifiers;
	XUngrabKey (display, _tmp4_, (guint) _tmp5_, (Window) xid);
	_g_object_unref0 (rootwin);
}


void gpaste_daemon_keybinder_rebind (GPasteDaemonKeybinder* self, const gchar* accelerator) {
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (accelerator != NULL);
	gpaste_daemon_keybinder_unbind (self);
	_tmp0_ = accelerator;
	gpaste_daemon_keybinder_activate (self, _tmp0_);
}


static void gpaste_daemon_keybinder_activate (GPasteDaemonKeybinder* self, const gchar* accelerator) {
	guint keysym = 0U;
	GdkModifierType mod = 0;
	const gchar* _tmp0_;
	guint _tmp1_ = 0U;
	GdkModifierType _tmp2_ = 0;
	Display* _tmp3_ = NULL;
	Display* display;
	Display* _tmp4_;
	guint _tmp5_;
	guchar _tmp6_ = '\0';
	GdkModifierType _tmp7_;
	gint _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (accelerator != NULL);
	_tmp0_ = accelerator;
	gtk_accelerator_parse (_tmp0_, &_tmp1_, &_tmp2_);
	keysym = _tmp1_;
	mod = _tmp2_;
	_tmp3_ = gdk_x11_get_default_xdisplay ();
	display = _tmp3_;
	_tmp4_ = display;
	_tmp5_ = keysym;
	_tmp6_ = XKeysymToKeycode (_tmp4_, (gulong) _tmp5_);
	gpaste_daemon_keybinder_set_keycode (self, (gint) _tmp6_);
	_tmp7_ = mod;
	gpaste_daemon_keybinder_set_modifiers (self, _tmp7_);
	_tmp8_ = self->priv->_keycode;
	if (_tmp8_ != 0) {
		GdkWindow* _tmp9_ = NULL;
		GdkWindow* _tmp10_;
		GdkWindow* rootwin;
		GdkWindow* _tmp11_;
		Window _tmp12_ = 0;
		XID xid;
		Display* _tmp13_;
		gint _tmp14_;
		GdkModifierType _tmp15_;
		XID _tmp16_;
		gdk_error_trap_push ();
		_tmp9_ = gdk_get_default_root_window ();
		_tmp10_ = _g_object_ref0 (_tmp9_);
		rootwin = _tmp10_;
		_tmp11_ = rootwin;
		_tmp12_ = gdk_x11_window_get_xid (_tmp11_);
		xid = (XID) _tmp12_;
		_tmp13_ = display;
		_tmp14_ = self->priv->_keycode;
		_tmp15_ = self->priv->_modifiers;
		_tmp16_ = xid;
		XGrabKey (_tmp13_, _tmp14_, (guint) _tmp15_, (Window) _tmp16_, FALSE, (gint) GrabModeAsync, (gint) GrabModeAsync);
		gdk_flush ();
		gdk_error_trap_pop_ignored ();
		_g_object_unref0 (rootwin);
	}
}


static GdkFilterReturn gpaste_daemon_keybinder_event_filter (GPasteDaemonKeybinder* self, GdkXEvent* gdk_xevent, GdkEvent* gdk_event) {
	GdkFilterReturn result = 0;
	XEvent xevent;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	XEvent _tmp2_;
	gint _tmp3_;
	gboolean _tmp8_;
	gboolean _tmp13_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (gdk_xevent != NULL, 0);
	g_return_val_if_fail (gdk_event != NULL, 0);
	xevent = *((XEvent*) (gdk_xevent));
	_tmp2_ = xevent;
	_tmp3_ = _tmp2_.type;
	if (_tmp3_ == ((gint) KeyPress)) {
		XEvent _tmp4_;
		XKeyEvent _tmp5_;
		guint _tmp6_;
		gint _tmp7_;
		_tmp4_ = xevent;
		_tmp5_ = _tmp4_.xkey;
		_tmp6_ = _tmp5_.keycode;
		_tmp7_ = self->priv->_keycode;
		_tmp1_ = _tmp6_ == ((guint) _tmp7_);
	} else {
		_tmp1_ = FALSE;
	}
	_tmp8_ = _tmp1_;
	if (_tmp8_) {
		XEvent _tmp9_;
		XKeyEvent _tmp10_;
		guint _tmp11_;
		GdkModifierType _tmp12_;
		_tmp9_ = xevent;
		_tmp10_ = _tmp9_.xkey;
		_tmp11_ = _tmp10_.state;
		_tmp12_ = self->priv->_modifiers;
		_tmp0_ = _tmp11_ == ((guint) _tmp12_);
	} else {
		_tmp0_ = FALSE;
	}
	_tmp13_ = _tmp0_;
	if (_tmp13_) {
		GPasteDaemonDBusServer* _tmp14_;
		GPasteDaemonDBusServer* _tmp15_;
		_tmp14_ = gpaste_daemon_dbus_server_get_instance ();
		_tmp15_ = _tmp14_;
		g_signal_emit_by_name (_tmp15_, "toggle-history");
	}
	result = GDK_FILTER_CONTINUE;
	return result;
}


GPasteDaemonKeybinder* gpaste_daemon_keybinder_get_instance (void) {
	GPasteDaemonKeybinder* result;
	GPasteDaemonKeybinder* _tmp0_;
	_tmp0_ = gpaste_daemon_keybinder__instance;
	result = _tmp0_;
	return result;
}


static void gpaste_daemon_keybinder_set_instance (GPasteDaemonKeybinder* value) {
	GPasteDaemonKeybinder* _tmp0_;
	GPasteDaemonKeybinder* _tmp1_;
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (gpaste_daemon_keybinder__instance);
	gpaste_daemon_keybinder__instance = _tmp1_;
}


gint gpaste_daemon_keybinder_get_keycode (GPasteDaemonKeybinder* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_keycode;
	result = _tmp0_;
	return result;
}


static void gpaste_daemon_keybinder_set_keycode (GPasteDaemonKeybinder* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_keycode = _tmp0_;
	g_object_notify ((GObject *) self, "keycode");
}


GdkModifierType gpaste_daemon_keybinder_get_modifiers (GPasteDaemonKeybinder* self) {
	GdkModifierType result;
	GdkModifierType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_modifiers;
	result = _tmp0_;
	return result;
}


static void gpaste_daemon_keybinder_set_modifiers (GPasteDaemonKeybinder* self, GdkModifierType value) {
	GdkModifierType _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_modifiers = _tmp0_;
	g_object_notify ((GObject *) self, "modifiers");
}


static void gpaste_daemon_keybinder_class_init (GPasteDaemonKeybinderClass * klass) {
	gpaste_daemon_keybinder_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GPasteDaemonKeybinderPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_gpaste_daemon_keybinder_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gpaste_daemon_keybinder_set_property;
	G_OBJECT_CLASS (klass)->finalize = gpaste_daemon_keybinder_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_DAEMON_KEYBINDER_KEYCODE, g_param_spec_int ("keycode", "keycode", "keycode", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_DAEMON_KEYBINDER_MODIFIERS, g_param_spec_flags ("modifiers", "modifiers", "modifiers", GDK_TYPE_MODIFIER_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void gpaste_daemon_keybinder_instance_init (GPasteDaemonKeybinder * self) {
	self->priv = GPASTE_DAEMON_KEYBINDER_GET_PRIVATE (self);
}


static void gpaste_daemon_keybinder_finalize (GObject* obj) {
	GPasteDaemonKeybinder * self;
	self = GPASTE_DAEMON_KEYBINDER (obj);
	G_OBJECT_CLASS (gpaste_daemon_keybinder_parent_class)->finalize (obj);
}


GType gpaste_daemon_keybinder_get_type (void) {
	static volatile gsize gpaste_daemon_keybinder_type_id__volatile = 0;
	if (g_once_init_enter (&gpaste_daemon_keybinder_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPasteDaemonKeybinderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpaste_daemon_keybinder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GPasteDaemonKeybinder), 0, (GInstanceInitFunc) gpaste_daemon_keybinder_instance_init, NULL };
		GType gpaste_daemon_keybinder_type_id;
		gpaste_daemon_keybinder_type_id = g_type_register_static (G_TYPE_OBJECT, "GPasteDaemonKeybinder", &g_define_type_info, 0);
		g_once_init_leave (&gpaste_daemon_keybinder_type_id__volatile, gpaste_daemon_keybinder_type_id);
	}
	return gpaste_daemon_keybinder_type_id__volatile;
}


static void _vala_gpaste_daemon_keybinder_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GPasteDaemonKeybinder * self;
	self = GPASTE_DAEMON_KEYBINDER (object);
	switch (property_id) {
		case GPASTE_DAEMON_KEYBINDER_KEYCODE:
		g_value_set_int (value, gpaste_daemon_keybinder_get_keycode (self));
		break;
		case GPASTE_DAEMON_KEYBINDER_MODIFIERS:
		g_value_set_flags (value, gpaste_daemon_keybinder_get_modifiers (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gpaste_daemon_keybinder_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GPasteDaemonKeybinder * self;
	self = GPASTE_DAEMON_KEYBINDER (object);
	switch (property_id) {
		case GPASTE_DAEMON_KEYBINDER_KEYCODE:
		gpaste_daemon_keybinder_set_keycode (self, g_value_get_int (value));
		break;
		case GPASTE_DAEMON_KEYBINDER_MODIFIERS:
		gpaste_daemon_keybinder_set_modifiers (self, g_value_get_flags (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



