/* settings.c generated by valac 0.14.0, the Vala compiler
 * generated from settings.vala, do not modify */

/*
 *      This file is part of GPaste.
 *
 *      Copyright 2011 Marc-Antoine Perennou <Marc-Antoine@Perennou.com>
 *
 *      GPaste is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      GPaste is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with GPaste.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define GPASTE_DAEMON_TYPE_SETTINGS (gpaste_daemon_settings_get_type ())
#define GPASTE_DAEMON_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_DAEMON_TYPE_SETTINGS, GPasteDaemonSettings))
#define GPASTE_DAEMON_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_DAEMON_TYPE_SETTINGS, GPasteDaemonSettingsClass))
#define GPASTE_DAEMON_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_DAEMON_TYPE_SETTINGS))
#define GPASTE_DAEMON_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_DAEMON_TYPE_SETTINGS))
#define GPASTE_DAEMON_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_DAEMON_TYPE_SETTINGS, GPasteDaemonSettingsClass))

typedef struct _GPasteDaemonSettings GPasteDaemonSettings;
typedef struct _GPasteDaemonSettingsClass GPasteDaemonSettingsClass;
typedef struct _GPasteDaemonSettingsPrivate GPasteDaemonSettingsPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define GPASTE_DAEMON_TYPE_DBUS_SERVER (gpaste_daemon_dbus_server_get_type ())
#define GPASTE_DAEMON_DBUS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_DAEMON_TYPE_DBUS_SERVER, GPasteDaemonDBusServer))
#define GPASTE_DAEMON_DBUS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_DAEMON_TYPE_DBUS_SERVER, GPasteDaemonDBusServerClass))
#define GPASTE_DAEMON_IS_DBUS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_DAEMON_TYPE_DBUS_SERVER))
#define GPASTE_DAEMON_IS_DBUS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_DAEMON_TYPE_DBUS_SERVER))
#define GPASTE_DAEMON_DBUS_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_DAEMON_TYPE_DBUS_SERVER, GPasteDaemonDBusServerClass))

typedef struct _GPasteDaemonDBusServer GPasteDaemonDBusServer;
typedef struct _GPasteDaemonDBusServerClass GPasteDaemonDBusServerClass;

#define GPASTE_DAEMON_TYPE_KEYBINDER (gpaste_daemon_keybinder_get_type ())
#define GPASTE_DAEMON_KEYBINDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_DAEMON_TYPE_KEYBINDER, GPasteDaemonKeybinder))
#define GPASTE_DAEMON_KEYBINDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_DAEMON_TYPE_KEYBINDER, GPasteDaemonKeybinderClass))
#define GPASTE_DAEMON_IS_KEYBINDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_DAEMON_TYPE_KEYBINDER))
#define GPASTE_DAEMON_IS_KEYBINDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_DAEMON_TYPE_KEYBINDER))
#define GPASTE_DAEMON_KEYBINDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_DAEMON_TYPE_KEYBINDER, GPasteDaemonKeybinderClass))

typedef struct _GPasteDaemonKeybinder GPasteDaemonKeybinder;
typedef struct _GPasteDaemonKeybinderClass GPasteDaemonKeybinderClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _GPasteDaemonSettings {
	GObject parent_instance;
	GPasteDaemonSettingsPrivate * priv;
};

struct _GPasteDaemonSettingsClass {
	GObjectClass parent_class;
};

struct _GPasteDaemonSettingsPrivate {
	GSettings* settings;
	gboolean _primary_to_history;
	guint32 _max_history_size;
	gboolean _synchronize_clipboards;
	gboolean _track_changes;
	gboolean _save_history;
	gchar* _keyboard_shortcut;
};


static gpointer gpaste_daemon_settings_parent_class = NULL;
static GPasteDaemonSettings* gpaste_daemon_settings__instance;
static GPasteDaemonSettings* gpaste_daemon_settings__instance = NULL;

GType gpaste_daemon_settings_get_type (void) G_GNUC_CONST;
#define GPASTE_DAEMON_SETTINGS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPASTE_DAEMON_TYPE_SETTINGS, GPasteDaemonSettingsPrivate))
enum  {
	GPASTE_DAEMON_SETTINGS_DUMMY_PROPERTY,
	GPASTE_DAEMON_SETTINGS_PRIMARY_TO_HISTORY,
	GPASTE_DAEMON_SETTINGS_MAX_HISTORY_SIZE,
	GPASTE_DAEMON_SETTINGS_SYNCHRONIZE_CLIPBOARDS,
	GPASTE_DAEMON_SETTINGS_TRACK_CHANGES,
	GPASTE_DAEMON_SETTINGS_SAVE_HISTORY,
	GPASTE_DAEMON_SETTINGS_KEYBOARD_SHORTCUT
};
void gpaste_daemon_settings_set_tracking_state (GPasteDaemonSettings* self, gboolean state);
static void gpaste_daemon_settings_set_track_changes (GPasteDaemonSettings* self, gboolean value);
static GPasteDaemonSettings* gpaste_daemon_settings_new (void);
static GPasteDaemonSettings* gpaste_daemon_settings_construct (GType object_type);
static gboolean gpaste_daemon_settings_get_real_primary_to_history (GPasteDaemonSettings* self);
static void gpaste_daemon_settings_set_primary_to_history (GPasteDaemonSettings* self, gboolean value);
static guint32 gpaste_daemon_settings_get_real_max_history_size (GPasteDaemonSettings* self);
static void gpaste_daemon_settings_set_max_history_size (GPasteDaemonSettings* self, guint32 value);
static gboolean gpaste_daemon_settings_get_real_synchronize_clipboards (GPasteDaemonSettings* self);
static void gpaste_daemon_settings_set_synchronize_clipboards (GPasteDaemonSettings* self, gboolean value);
static gboolean gpaste_daemon_settings_get_real_track_changes (GPasteDaemonSettings* self);
static gboolean gpaste_daemon_settings_get_real_save_history (GPasteDaemonSettings* self);
static void gpaste_daemon_settings_set_save_history (GPasteDaemonSettings* self, gboolean value);
static gchar* gpaste_daemon_settings_get_real_keyboard_shortcut (GPasteDaemonSettings* self);
static void gpaste_daemon_settings_set_keyboard_shortcut (GPasteDaemonSettings* self, const gchar* value);
static void __lambda1_ (GPasteDaemonSettings* self, const gchar* key);
GType gpaste_daemon_dbus_server_get_type (void) G_GNUC_CONST;
guint gpaste_daemon_dbus_server_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GPasteDaemonDBusServer* gpaste_daemon_dbus_server_get_instance (void);
gboolean gpaste_daemon_settings_get_track_changes (GPasteDaemonSettings* self);
GType gpaste_daemon_keybinder_get_type (void) G_GNUC_CONST;
GPasteDaemonKeybinder* gpaste_daemon_keybinder_get_instance (void);
void gpaste_daemon_keybinder_rebind (GPasteDaemonKeybinder* self, const gchar* accelerator);
const gchar* gpaste_daemon_settings_get_keyboard_shortcut (GPasteDaemonSettings* self);
static void ___lambda1__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self);
GPasteDaemonSettings* gpaste_daemon_settings_get_instance (void);
gboolean gpaste_daemon_settings_get_primary_to_history (GPasteDaemonSettings* self);
guint32 gpaste_daemon_settings_get_max_history_size (GPasteDaemonSettings* self);
gboolean gpaste_daemon_settings_get_synchronize_clipboards (GPasteDaemonSettings* self);
gboolean gpaste_daemon_settings_get_save_history (GPasteDaemonSettings* self);
static void gpaste_daemon_settings_finalize (GObject* obj);
static void _vala_gpaste_daemon_settings_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gpaste_daemon_settings_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


void gpaste_daemon_settings_set_tracking_state (GPasteDaemonSettings* self, gboolean state) {
	gboolean _tmp0_;
	GSettings* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = state;
	gpaste_daemon_settings_set_track_changes (self, _tmp0_);
	_tmp1_ = self->priv->settings;
	_tmp2_ = state;
	g_settings_set_boolean (_tmp1_, "track-changes", _tmp2_);
}


static void __lambda1_ (GPasteDaemonSettings* self, const gchar* key) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	static GQuark _tmp2_label2 = 0;
	static GQuark _tmp2_label3 = 0;
	static GQuark _tmp2_label4 = 0;
	static GQuark _tmp2_label5 = 0;
	g_return_if_fail (key != NULL);
	_tmp0_ = key;
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("primary-to-history")))) {
		switch (0) {
			default:
			{
				gboolean _tmp4_;
				gboolean _tmp5_;
				_tmp4_ = gpaste_daemon_settings_get_real_primary_to_history (self);
				_tmp5_ = _tmp4_;
				gpaste_daemon_settings_set_primary_to_history (self, _tmp5_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("max-history-size")))) {
		switch (0) {
			default:
			{
				guint32 _tmp6_;
				guint32 _tmp7_;
				_tmp6_ = gpaste_daemon_settings_get_real_max_history_size (self);
				_tmp7_ = _tmp6_;
				gpaste_daemon_settings_set_max_history_size (self, _tmp7_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("synchronize-clipboards")))) {
		switch (0) {
			default:
			{
				gboolean _tmp8_;
				gboolean _tmp9_;
				_tmp8_ = gpaste_daemon_settings_get_real_synchronize_clipboards (self);
				_tmp9_ = _tmp8_;
				gpaste_daemon_settings_set_synchronize_clipboards (self, _tmp9_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("track-changes")))) {
		switch (0) {
			default:
			{
				gboolean _tmp10_;
				gboolean _tmp11_;
				GPasteDaemonDBusServer* _tmp12_;
				GPasteDaemonDBusServer* _tmp13_;
				gboolean _tmp14_;
				_tmp10_ = gpaste_daemon_settings_get_real_track_changes (self);
				_tmp11_ = _tmp10_;
				gpaste_daemon_settings_set_track_changes (self, _tmp11_);
				_tmp12_ = gpaste_daemon_dbus_server_get_instance ();
				_tmp13_ = _tmp12_;
				_tmp14_ = self->priv->_track_changes;
				g_signal_emit_by_name (_tmp13_, "tracking", _tmp14_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("save-history")))) {
		switch (0) {
			default:
			{
				gboolean _tmp15_;
				gboolean _tmp16_;
				_tmp15_ = gpaste_daemon_settings_get_real_save_history (self);
				_tmp16_ = _tmp15_;
				gpaste_daemon_settings_set_save_history (self, _tmp16_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("keyboard-shortcut")))) {
		switch (0) {
			default:
			{
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				GPasteDaemonKeybinder* _tmp20_;
				GPasteDaemonKeybinder* _tmp21_;
				const gchar* _tmp22_;
				_tmp17_ = gpaste_daemon_settings_get_real_keyboard_shortcut (self);
				_tmp18_ = _tmp17_;
				_tmp19_ = _tmp18_;
				gpaste_daemon_settings_set_keyboard_shortcut (self, _tmp19_);
				_g_free0 (_tmp19_);
				_tmp20_ = gpaste_daemon_keybinder_get_instance ();
				_tmp21_ = _tmp20_;
				_tmp22_ = self->priv->_keyboard_shortcut;
				gpaste_daemon_keybinder_rebind (_tmp21_, _tmp22_);
				break;
			}
		}
	}
}


static void ___lambda1__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self) {
	__lambda1_ (self, key);
}


static GPasteDaemonSettings* gpaste_daemon_settings_construct (GType object_type) {
	GPasteDaemonSettings * self = NULL;
	GSettings* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	guint32 _tmp3_;
	guint32 _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GSettings* _tmp14_;
	self = (GPasteDaemonSettings*) g_object_new (object_type, NULL);
	_tmp0_ = g_settings_new ("org.gnome.GPaste");
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = gpaste_daemon_settings_get_real_primary_to_history (self);
	_tmp2_ = _tmp1_;
	gpaste_daemon_settings_set_primary_to_history (self, _tmp2_);
	_tmp3_ = gpaste_daemon_settings_get_real_max_history_size (self);
	_tmp4_ = _tmp3_;
	gpaste_daemon_settings_set_max_history_size (self, _tmp4_);
	_tmp5_ = gpaste_daemon_settings_get_real_synchronize_clipboards (self);
	_tmp6_ = _tmp5_;
	gpaste_daemon_settings_set_synchronize_clipboards (self, _tmp6_);
	_tmp7_ = gpaste_daemon_settings_get_real_track_changes (self);
	_tmp8_ = _tmp7_;
	gpaste_daemon_settings_set_track_changes (self, _tmp8_);
	_tmp9_ = gpaste_daemon_settings_get_real_save_history (self);
	_tmp10_ = _tmp9_;
	gpaste_daemon_settings_set_save_history (self, _tmp10_);
	_tmp11_ = gpaste_daemon_settings_get_real_keyboard_shortcut (self);
	_tmp12_ = _tmp11_;
	_tmp13_ = _tmp12_;
	gpaste_daemon_settings_set_keyboard_shortcut (self, _tmp13_);
	_g_free0 (_tmp13_);
	_tmp14_ = self->priv->settings;
	g_signal_connect_object (_tmp14_, "changed", (GCallback) ___lambda1__g_settings_changed, self, 0);
	return self;
}


static GPasteDaemonSettings* gpaste_daemon_settings_new (void) {
	return gpaste_daemon_settings_construct (GPASTE_DAEMON_TYPE_SETTINGS);
}


GPasteDaemonSettings* gpaste_daemon_settings_get_instance (void) {
	GPasteDaemonSettings* result;
	GPasteDaemonSettings* _tmp0_;
	GPasteDaemonSettings* _tmp2_;
	_tmp0_ = gpaste_daemon_settings__instance;
	if (_tmp0_ == NULL) {
		GPasteDaemonSettings* _tmp1_;
		_tmp1_ = gpaste_daemon_settings_new ();
		_g_object_unref0 (gpaste_daemon_settings__instance);
		gpaste_daemon_settings__instance = _tmp1_;
	}
	_tmp2_ = gpaste_daemon_settings__instance;
	result = _tmp2_;
	return result;
}


static gboolean gpaste_daemon_settings_get_real_primary_to_history (GPasteDaemonSettings* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_boolean (_tmp0_, "primary-to-history");
	result = _tmp1_;
	return result;
}


static guint32 gpaste_daemon_settings_get_real_max_history_size (GPasteDaemonSettings* self) {
	guint32 result;
	GSettings* _tmp0_;
	GVariant* _tmp1_ = NULL;
	GVariant* _tmp2_;
	guint32 _tmp3_ = 0U;
	guint32 _tmp4_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_value (_tmp0_, "max-history-size");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_variant_get_uint32 (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_variant_unref0 (_tmp2_);
	result = _tmp4_;
	return result;
}


static gboolean gpaste_daemon_settings_get_real_synchronize_clipboards (GPasteDaemonSettings* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_boolean (_tmp0_, "synchronize-clipboards");
	result = _tmp1_;
	return result;
}


static gboolean gpaste_daemon_settings_get_real_track_changes (GPasteDaemonSettings* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_boolean (_tmp0_, "track-changes");
	result = _tmp1_;
	return result;
}


static gboolean gpaste_daemon_settings_get_real_save_history (GPasteDaemonSettings* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_boolean (_tmp0_, "save-history");
	result = _tmp1_;
	return result;
}


static gchar* gpaste_daemon_settings_get_real_keyboard_shortcut (GPasteDaemonSettings* self) {
	gchar* result;
	GSettings* _tmp0_;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_string (_tmp0_, "keyboard-shortcut");
	result = _tmp1_;
	return result;
}


gboolean gpaste_daemon_settings_get_primary_to_history (GPasteDaemonSettings* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_primary_to_history;
	result = _tmp0_;
	return result;
}


static void gpaste_daemon_settings_set_primary_to_history (GPasteDaemonSettings* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_primary_to_history = _tmp0_;
	g_object_notify ((GObject *) self, "primary-to-history");
}


guint32 gpaste_daemon_settings_get_max_history_size (GPasteDaemonSettings* self) {
	guint32 result;
	guint32 _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_max_history_size;
	result = _tmp0_;
	return result;
}


static void gpaste_daemon_settings_set_max_history_size (GPasteDaemonSettings* self, guint32 value) {
	guint32 _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_max_history_size = _tmp0_;
	g_object_notify ((GObject *) self, "max-history-size");
}


gboolean gpaste_daemon_settings_get_synchronize_clipboards (GPasteDaemonSettings* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_synchronize_clipboards;
	result = _tmp0_;
	return result;
}


static void gpaste_daemon_settings_set_synchronize_clipboards (GPasteDaemonSettings* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_synchronize_clipboards = _tmp0_;
	g_object_notify ((GObject *) self, "synchronize-clipboards");
}


gboolean gpaste_daemon_settings_get_track_changes (GPasteDaemonSettings* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_track_changes;
	result = _tmp0_;
	return result;
}


static void gpaste_daemon_settings_set_track_changes (GPasteDaemonSettings* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_track_changes = _tmp0_;
	g_object_notify ((GObject *) self, "track-changes");
}


gboolean gpaste_daemon_settings_get_save_history (GPasteDaemonSettings* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_save_history;
	result = _tmp0_;
	return result;
}


static void gpaste_daemon_settings_set_save_history (GPasteDaemonSettings* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_save_history = _tmp0_;
	g_object_notify ((GObject *) self, "save-history");
}


const gchar* gpaste_daemon_settings_get_keyboard_shortcut (GPasteDaemonSettings* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_keyboard_shortcut;
	result = _tmp0_;
	return result;
}


static void gpaste_daemon_settings_set_keyboard_shortcut (GPasteDaemonSettings* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_keyboard_shortcut);
	self->priv->_keyboard_shortcut = _tmp1_;
	g_object_notify ((GObject *) self, "keyboard-shortcut");
}


static void gpaste_daemon_settings_class_init (GPasteDaemonSettingsClass * klass) {
	gpaste_daemon_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GPasteDaemonSettingsPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_gpaste_daemon_settings_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gpaste_daemon_settings_set_property;
	G_OBJECT_CLASS (klass)->finalize = gpaste_daemon_settings_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_DAEMON_SETTINGS_PRIMARY_TO_HISTORY, g_param_spec_boolean ("primary-to-history", "primary-to-history", "primary-to-history", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_DAEMON_SETTINGS_MAX_HISTORY_SIZE, g_param_spec_uint ("max-history-size", "max-history-size", "max-history-size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_DAEMON_SETTINGS_SYNCHRONIZE_CLIPBOARDS, g_param_spec_boolean ("synchronize-clipboards", "synchronize-clipboards", "synchronize-clipboards", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_DAEMON_SETTINGS_TRACK_CHANGES, g_param_spec_boolean ("track-changes", "track-changes", "track-changes", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_DAEMON_SETTINGS_SAVE_HISTORY, g_param_spec_boolean ("save-history", "save-history", "save-history", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_DAEMON_SETTINGS_KEYBOARD_SHORTCUT, g_param_spec_string ("keyboard-shortcut", "keyboard-shortcut", "keyboard-shortcut", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void gpaste_daemon_settings_instance_init (GPasteDaemonSettings * self) {
	self->priv = GPASTE_DAEMON_SETTINGS_GET_PRIVATE (self);
}


static void gpaste_daemon_settings_finalize (GObject* obj) {
	GPasteDaemonSettings * self;
	self = GPASTE_DAEMON_SETTINGS (obj);
	_g_object_unref0 (self->priv->settings);
	_g_free0 (self->priv->_keyboard_shortcut);
	G_OBJECT_CLASS (gpaste_daemon_settings_parent_class)->finalize (obj);
}


GType gpaste_daemon_settings_get_type (void) {
	static volatile gsize gpaste_daemon_settings_type_id__volatile = 0;
	if (g_once_init_enter (&gpaste_daemon_settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPasteDaemonSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpaste_daemon_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GPasteDaemonSettings), 0, (GInstanceInitFunc) gpaste_daemon_settings_instance_init, NULL };
		GType gpaste_daemon_settings_type_id;
		gpaste_daemon_settings_type_id = g_type_register_static (G_TYPE_OBJECT, "GPasteDaemonSettings", &g_define_type_info, 0);
		g_once_init_leave (&gpaste_daemon_settings_type_id__volatile, gpaste_daemon_settings_type_id);
	}
	return gpaste_daemon_settings_type_id__volatile;
}


static void _vala_gpaste_daemon_settings_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GPasteDaemonSettings * self;
	self = GPASTE_DAEMON_SETTINGS (object);
	switch (property_id) {
		case GPASTE_DAEMON_SETTINGS_PRIMARY_TO_HISTORY:
		g_value_set_boolean (value, gpaste_daemon_settings_get_primary_to_history (self));
		break;
		case GPASTE_DAEMON_SETTINGS_MAX_HISTORY_SIZE:
		g_value_set_uint (value, gpaste_daemon_settings_get_max_history_size (self));
		break;
		case GPASTE_DAEMON_SETTINGS_SYNCHRONIZE_CLIPBOARDS:
		g_value_set_boolean (value, gpaste_daemon_settings_get_synchronize_clipboards (self));
		break;
		case GPASTE_DAEMON_SETTINGS_TRACK_CHANGES:
		g_value_set_boolean (value, gpaste_daemon_settings_get_track_changes (self));
		break;
		case GPASTE_DAEMON_SETTINGS_SAVE_HISTORY:
		g_value_set_boolean (value, gpaste_daemon_settings_get_save_history (self));
		break;
		case GPASTE_DAEMON_SETTINGS_KEYBOARD_SHORTCUT:
		g_value_set_string (value, gpaste_daemon_settings_get_keyboard_shortcut (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gpaste_daemon_settings_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GPasteDaemonSettings * self;
	self = GPASTE_DAEMON_SETTINGS (object);
	switch (property_id) {
		case GPASTE_DAEMON_SETTINGS_PRIMARY_TO_HISTORY:
		gpaste_daemon_settings_set_primary_to_history (self, g_value_get_boolean (value));
		break;
		case GPASTE_DAEMON_SETTINGS_MAX_HISTORY_SIZE:
		gpaste_daemon_settings_set_max_history_size (self, g_value_get_uint (value));
		break;
		case GPASTE_DAEMON_SETTINGS_SYNCHRONIZE_CLIPBOARDS:
		gpaste_daemon_settings_set_synchronize_clipboards (self, g_value_get_boolean (value));
		break;
		case GPASTE_DAEMON_SETTINGS_TRACK_CHANGES:
		gpaste_daemon_settings_set_track_changes (self, g_value_get_boolean (value));
		break;
		case GPASTE_DAEMON_SETTINGS_SAVE_HISTORY:
		gpaste_daemon_settings_set_save_history (self, g_value_get_boolean (value));
		break;
		case GPASTE_DAEMON_SETTINGS_KEYBOARD_SHORTCUT:
		gpaste_daemon_settings_set_keyboard_shortcut (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



